<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2006 Volker Biberger - Sitekick <info@sitekick.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Selection class for the 'sk_calendar' extension.
 *
 * @author	Volker Biberger - Sitekick <info@sitekick.de>
 */

// Common class for selecting events
class tx_skcalendar_selection {
var $conf;
var $result;
var $session_vars;
var $recurr_events = TRUE;

	// Init
	function tx_skcalendar_selection($conf) {
		$confArr = unserialize($GLOBALS['TYPO3_CONF_VARS']['EXT']['extConf']['sk_calendar']);
		$this->conf = $conf;
		$this->getSession();

		if (!$this->session_vars[$this->conf['filters']['sys_language_uid']]) {
		
		$tables = array('category','targetgroup','organizer','location');
		
		while (list(,$table) = each ($tables)) {
			$select_fields = '*';
			$from_table = 'tx_skcalendar_' . $table;
			$where_clause = 'NOT hidden AND NOT deleted AND sys_language_uid=' . intval($this->conf['filters']['sys_language_uid']);
			$orderBy = 'uid';
			$return = $GLOBALS['TYPO3_DB']->exec_SELECTquery($select_fields,$from_table,$where_clause,$groupBy,$orderBy);
			$arr = array();
			while ($data= $GLOBALS['TYPO3_DB']->sql_fetch_assoc($return)) {
				$data['uid'] = $data['l18n_parent'] ? $data['l18n_parent'] : $data['uid'];
				if ($confArr['usedam'] < 2)  {
					$data['image'] = $data['image'] ? '<img src="uploads/tx_skcalendar/' . $data['image'] . '">' : FALSE;
					$data['logo'] = $data['logo'] ? '<img src="uploads/tx_skcalendar/' . $data['logo'] . '">' : FALSE;
					//nderunge damit Icons auch angezeigt werden johpie
					$data['icon'] = $data['icon'] ? '<img src="uploads/tx_skcalendar/' . $data['icon'] . '">' : FALSE;
				} else {
					$data['image'] = FALSE;
					$data['logo'] = FALSE;
					$data['icon'] = FALSE;
				}
				//Using of DAM
				if ($confArr['usedam'])  {
					if ($data['dam_image']) {
						$damFiles = tx_dam_db::getReferencedFiles($from_table, $uid, 'dam_image');
						while (list(,$val) = each($damFiles['files'])) {
							$data['image'] = '<img src="'.$val.'">';
						}
					}
					if ($data['dam_logo']) {
						$damFiles = tx_dam_db::getReferencedFiles($from_table, $uid, 'dam_logo');
						while (list(,$val) = each($damFiles['files'])) {
							$data['logo'] = '<img src="'.$val.'">';
						}
					}
					if ($data['dam_icon']) {
						$damFiles = tx_dam_db::getReferencedFiles($from_table, $uid, 'dam_icon');
						while (list(,$val) = each($damFiles['files'])) {
							$data['icon'] = '<img src="'.$val.'">';
						}
					}
				}
				$arr[$data['uid']] = $data;
			}
			$this->session_vars[$this->conf['filters']['sys_language_uid']][$table] = $arr;
		
		}
	

		}
		$this->conf['filters']['category'] =implode(',',$this->conf['filters']['category']);
		$this->conf['filters']['targetgroup'] =implode(',',$this->conf['filters']['targetgroup']);
		$this->conf['filters']['location'] =implode(',',$this->conf['filters']['location']);
		$this->conf['filters']['organizer'] =implode(',',$this->conf['filters']['organizer']);
		
	}
	

	
	// Prepare Query
	function prepareQuery() {
			$this->select_fields = '*';
			$this->from_table = 'tx_skcalendar_event';
			$this->where_clause = 'NOT hidden AND NOT deleted AND sys_language_uid='. intval($this->conf['filters']['sys_language_uid']);
			$this->where_clause .= ' AND ((startdate BETWEEN ' . $this->conf['filters']['startdate'] . ' AND ' . $this->conf['filters']['enddate'] . ' OR enddate BETWEEN ' . $this->conf['filters']['startdate'] . ' AND ' . $this->conf['filters']['enddate'] . ') OR ((recurring AND startdate < ' . $this->conf['filters']['startdate'] . ') AND ((recurr_until >= ' . $this->conf['filters']['startdate'] . ') OR NOT recurr_until)))';
			$this->where_clause .= $this->conf['filters']['category'] ? ' AND category IN (' . $this->conf['filters']['category'] . ')' : '';
			$this->where_clause .= $this->conf['filters']['targetgroup'] ? ' AND targetgroup IN (' . $this->conf['filters']['targetgroup'] . ')' : '';
			$this->where_clause .= $this->conf['filters']['organizer'] ? ' AND organizer IN (' . $this->conf['filters']['organizer'] . ')' : '';
			$this->where_clause .= $this->conf['filters']['location'] ? ' AND location IN (' . $this->conf['filters']['location'] . ')' : '';
			$this->where_clause .= $this->conf['filters']['sword'] ? ' AND (title LIKE \'%' . $GLOBALS['TYPO3_DB']->quoteStr( $this->conf['filters']['sword'], $this->from_table ) . '%\' OR description LIKE \'%' . $GLOBALS['TYPO3_DB']->quoteStr( $this->conf['filters']['sword'], $this->from_table ) . '%\')' : '';
			$this->where_clause .= $this->conf['filters']['uid'] ? ' AND uid=' . intval($this->conf['filters']['uid']) : '';
			$this->where_clause .= $this->conf['general']['source_pidlist'] ? ' AND pid IN (' . $this->conf['general']['source_pidlist'] . ')' : '';
			$this->where_clause .= $this->conf['system']['usergroup'] ? ' AND fe_group IN (' . implode(',',$this->conf['system']['usergroup']) . ')' : '';
	}

	// Query Db
	function queryDb() {
			$orderBy = 'startdate,start_time DESC';
			$return = $GLOBALS['TYPO3_DB']->exec_SELECTquery($this->select_fields,$this->from_table,$this->where_clause,$groupBy,$orderBy);

			$this->results = array();
			while ($data= $GLOBALS['TYPO3_DB']->sql_fetch_assoc($return)) {
				$data['category'] = $data['category'] ? $this->session_vars[$this->conf['filters']['sys_language_uid']]['category'][$data['category']] : FALSE;
				$data['targetgroup'] = $data['targetgroup'] ? $this->session_vars[$this->conf['filters']['sys_language_uid']]['targetgroup'][$data['targetgroup']] : FALSE;
				$data['location'] = $data['location'] ? $this->session_vars[$this->conf['filters']['sys_language_uid']]['location'][$data['location']] : FALSE;
				$data['organizer'] = $data['organizer'] ? $this->session_vars[$this->conf['filters']['sys_language_uid']]['organizer'][$data['organizer']] : FALSE;
				$this->results[] = $data;
			}
	}
	
	// filter events
	function filterEvents() {
	
	}
	
	// Add recurring events
	function addRecurring() {
		// if the event has no limit in recurring
		$recurr_until_fallback = $this->conf['filters']['enddate'];

		// get exeptions
		$select_fields = '*';
		$from_table = 'tx_skcalendar_exeption';
		$where_clause = 'NOT hidden AND NOT deleted AND exeption_date >= ' . $GLOBALS['TYPO3_DB']->quoteStr($this->conf['filters']['startdate'],$from_table) . ' AND exeption_date <= ' . $GLOBALS['TYPO3_DB']->quoteStr($this->conf['filters']['enddate'],$from_table);
		$return = $GLOBALS['TYPO3_DB']->exec_SELECTquery($select_fields,$from_table,$where_clause,$groupBy,$orderBy);

		$exept_arr = array();
		while ($data= $GLOBALS['TYPO3_DB']->sql_fetch_assoc($return)) {
			$exept_arr[$data['uid']] = $data['exeption_date'];
		}
		$events_clean = array();
		while (list(,$event) = each ($this->results)) {
			$exeptions = explode(',',$event['exeptions']);
			$exept_clean = array();
			while (list(,$exeption) = each ($exeptions)) {
				$exept_clean[] = $exept_arr[$exeption];
			}
			$exeptions = $exept_clean;
	
			if (!$event['recurr_until']) $event['recurr_until'] = $recurr_until_fallback;

			$uid = $event['uid'];
			$event['is_recurring'] = $event['recurring'] ? TRUE : FALSE;

			switch ($event['recurring']) {
		
			// none
			case 0:
				$events_clean[] = $event;
			break;
			
			// daily
			case 1:
			while ($event['startdate'] <= $event['recurr_until'])
			{
				if (!in_array($event['startdate'],$exeptions) && $event['startdate'] >= $this->conf['filters']['startdate']) // ignore exepted dates
				{
					$event['uid'] = $uid .  '_re'.$event['startdate']; // distinction between different Ghostcopies	
					$events_clean[] = $event;
				}
				$date = date('Y-m-d', $event['startdate']);
				$date = explode('-',$date);
				$event['startdate'] = mktime(0,0,0,$date[1],$date[2]+1,$date[0]);
			}			
			break;
				
			// weekly
			case 2:
			while ($event['startdate'] <= $event['recurr_until'])
			{
				if (!in_array($event['startdate'],$exeptions) && $event['startdate'] >= $this->conf['filters']['startdate']) // ignore exepted dates
				{
					$event['uid'] = $uid .  '_re'.$event['startdate']; // distinction between different Ghostcopies	
					$events_clean[] = $event;
				}
				$date = date('Y-m-d', $event['startdate']);
				$date = explode('-',$date);
				$event['startdate'] = mktime(0,0,0,$date[1],$date[2]+7,$date[0]);
			}			
			break;
			
				
			// 2weekly
			case 6:
			while ($event['startdate'] <= $event['recurr_until'])
			{
				if (!in_array($event['startdate'],$exeptions) && $event['startdate'] >= $this->conf['filters']['startdate']) // ignore exepted dates
				{
					$event['uid'] = $uid .  '_re'.$event['startdate']; // distinction between different Ghostcopies	
					$events_clean[] = $event;
				}
				$date = date('Y-m-d', $event['startdate']);
				$date = explode('-',$date);
				$event['startdate'] = mktime(0,0,0,$date[1],$date[2]+14,$date[0]);
			}			
			break;
			
			// monthly
			case 3:
			while ($event['startdate'] <= $event['recurr_until'])
			{
				if (!in_array($event['startdate'],$exeptions) && $event['startdate'] >= $this->conf['filters']['startdate']) // ignore exepted dates
				{
					$event['uid'] = $uid .  '_re'.$event['startdate']; // distinction between different Ghostcopies	
					$events_clean[] = $event;
				}
				$date = date('Y-m-d', $event['startdate']);
				$date = explode('-',$date);
				$event['startdate'] = mktime(0,0,0,$date[1]+1,$date[2],$date[0]);
			}			
			break;
			
			// yearly
			case 4:
			while ($event['startdate'] <= $event['recurr_until'])
			{
				if (!in_array($event['startdate'],$exeptions) && $event['startdate'] >= $this->conf['filters']['startdate']) // ignore exepted dates
				{
					$event['uid'] = $uid .  '_re'.$event['startdate']; // distinction between different Ghostcopies	
					$events_clean[] = $event;
				}
				$date = date('Y-m-d', $event['startdate']);
				$date = explode('-',$date);
				$event['startdate'] = mktime(0,0,0,$date[1],$date[2],$date[0]+1);
			}			
			break;
			
			// monthly on a certain day
			case 5:
			while ($event['startdate'] <= $event['recurr_until'])
			{
				if (!in_array($event['startdate'],$exeptions) && $event['startdate'] >= $this->conf['filters']['startdate']) // ignore exepted dates
				{
					$event['uid'] = $uid .  '_re'.$event['startdate']; // distinction between different Ghostcopies	
					$events_clean[] = $event;
				}
				$date = date('Y-m-d', $event['startdate']);
				$date = explode('-',$date);
				// weekday of first - the following month
				$w_new = date('w',mktime(0,0,0,$date[1]+1,1,$date[0]));
				if ($w_new == 0) $w = 7;
				$w_old =  date('w',$event['startdate']);
				if ($w_old == 0) $w_old = 7;
				if ($w_old < $w_new) $notch = 35; // 5 weeks
				else $notch = 28; // 4 weeks
					
				$event['startdate'] = mktime(0,0,0,$date[1],$date[2]+$notch,$date[0]);
			}			
			break;
			}
		}

		$this->results = $events_clean;
		
	}
			// resolve spanning Events
		function resolveSpaningEvents() {
		$array_clean = array();
			while (list(,$event) = each ($this->results)) {
			$count++;
			if ($event['startdate'] < $event['enddate']) {
				// we have a spanning event
				$parent_id = FALSE;
				$spancount = 0;
				$temp_clock = $event['end_time'];
				$event['end_time'] = 0;
				while ($event['startdate'] <= $event['enddate']) {
					$sortfield = $event['startdate'] . '_' . $event['start_time'] . '_' . $count;
					if (!$parent_id) {
						$parent_id = $sortfield;
						$uid = $event['uid'];
						$event['uid'] = $uid .  '_span'.$event['startdate'];
					}
					else {
						$event['uid'] = $uid .  '_span'.$event['startdate'];
						$event['start_time'] = 0; 
						$event['end_time'] = 0;
					}
					
					if ($event['startdate'] == $event['enddate']) {
						unset($event['enddate']);
						$event['end_time'] = $temp_clock;
					}
					$event['is_span'] = TRUE;
					$array_clean[$sortfield] = $event;
					$spancount++;
					$count++;
					$date = date('Y-m-d', $event['startdate']);
					$date = explode('-',$date);
					$event['startdate'] = mktime(0,0,0,$date[1],$date[2]+1,$date[0]);
				}
				$array_clean[$parent_id]['spancount'] = $spancount;

			}
			else {
				$sortfield = $event['startdate'] . '_' . $event['start_time'] . '_' . $count;
				$array_clean[$sortfield] = $event;
			}
		}
		ksort($array_clean);

		// Traverse array again to find dates that are spanning but also have other entries (->disabling spanning)
		while (list($key,$item) = each($array_clean)) {
			// get original uid for comparision
			$parent_key = explode('_',$item['uid']);
			$parent_key = $parent_key[0];
			
			if ($act_date != $item['startdate']) {
				$act_date = $item['startdate'];
				$daychange = TRUE;
			
			}
			else $daychange = FALSE;
				if (sizeof($spanning_items) > 0) {
			
				// Traverse $spanning_items for $events
				reset($spanning_items);
				while (list($key2,$entry) = each ($spanning_items)) {
 					if ($parent_key != $entry['uid']) {
 						if ($entry['enddate'] >= $act_date) {
 							$array_clean[$entry['sortkey']]['spancount'] = FALSE;
 						}
 						else {
 							unset($spanning_items[$entry['sortkey']]);
 						}
 					}
				}
			}
			if ($item['spancount']) {
				$spanning_items[] = array('enddate' => $item['enddate'], 'sortkey' => $key, 'uid' => $item['uid']);
			}
			 // in case there are already dates present on that day.
		}
		reset($array_clean);
		$this->results = $array_clean;

		}

	
	function debugCal() {
		while (list($id,$event) = each($this->results)) {
			$arr[$id] = date('d.m.Y',$event['startdate']) . ' - ' . $event['title'] . ' ('. $event['uid'] . ')';
		}
		debug($arr);
		reset($this->results);
	}
	
	// return results
	function getResults() {
		$this->prepareQuery();
		$this->queryDB();
		$this->filterEvents();
		if ($this->recurr_events) {
			$this->addRecurring();
			$this->resolveSpaningEvents();
		}
	//	$this->debugCal();
	}
	
	function close() {
		$this->saveSession();
	}
	
}

// FE Class for selecting events
class tx_skcalendar_selection_fe extends tx_skcalendar_selection{

	function tx_skcalendar_selection_fe($conf) {
		$this->tx_skcalendar_selection($conf);

	}
	
	function getSession() {
		$this->session_vars = $GLOBALS["TSFE"]->fe_user->getKey('ses','tx_skcalendar');
	}
	
	function saveSession() {
		$GLOBALS["TSFE"]->fe_user->setKey('ses','tx_skcalendar',$this->session_vars);

	}

	
}

// BE Class for selecting events
class tx_skcalendar_selection_be extends tx_skcalendar_selection{

	function tx_skcalendar_selection_be($conf) {
		$this->tx_skcalendar_selection($conf);
	}
	
	function getSession() {
		$this->session_vars = $GLOBALS["BE_USER"]->getSessionData('tx_skcalendar');
	}
	
	function saveSession() {
		$GLOBALS["BE_USER"]->setAndSaveSessionData ('tx_skcalendar', $this->session_vars);
	}

	
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/sk_calendar/class.tx_skcalendar_selection.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/sk_calendar/class.tx_skcalendar_selection.php']);
}



?>