<?PHP

class tx_skcalendar_gridedit {

	function tx_skcalendar_gridedit($container,$conf) {

	// constructor Class
	$this->conf = $conf;
	$this->events = $container->results;
	if (!$this->events) $this->events = Array();
	$this->year = date('Y',$conf['offset']);
	$this->month = date('m',$conf['offset']);
	$this->session_vars = $GLOBALS["BE_USER"]->getSessionData('tx_skcalendar');
	
	}
	
				/**
		* @return void
		* @desc create calendararray
		*/
		function createCalendar () {
			$from_m = intval(date('m',$this->conf['filters']['startdate']));
			$to_m = intval(date('m',$this->conf['filters']['enddate']));
			
			// forming the basic calendar array with the form $calendar[month][day]
			for ($temp=$from_m; $temp<=$to_m; $temp++)
			{
				$date_unix = mktime(0,0,0,$temp,1,$this->year);
				$now = mktime(0,0,0);
				$count_days = date("t",$date_unix);
				for ($day=1; $day<=$count_days; $day++)
				{
					$date_unix = mktime(0,0,0,$temp,$day,$this->year);
					$this->calendarArray[$temp][$day]['d_ts'] = $date_unix;
					$this->calendarArray[$temp][$day]['d_name']['no'] = strftime("%e",$date_unix);
					$this->calendarArray[$temp][$day]['d_name']['short'] = strftime("%a",$date_unix);
					$this->calendarArray[$temp][$day]['d_name']['initials'] = substr(strftime("%a",$date_unix),0,2);
					$this->calendarArray[$temp][$day]['d_name']['long'] = strftime("%A",$date_unix);
					if ($date_unix < $now) $this->calendarArray[$temp][$day]['style'] = 'past_weekday';
					else $this->calendarArray[$temp][$day]['style'] = 'weekday';
					if (date("w",$date_unix)==0) $this->calendarArray[$temp][$day]['style']='sunday'; // sunday
				}
			}
			while (list($name,$date) = each($this->holidays))
			{
				$date = explode('.',$date);
				if ($this->calendarArray[$date[1]]) {
					$this->calendarArray[$date[1]][$date[0]]['d_name']['short'] = $this->pi_getLL($name);
					$this->calendarArray[$date[1]][$date[0]]['d_name']['long'] = $this->pi_getLL($name);
					$this->calendarArray[$date[1]][$date[0]]['style']='holiday';
					$this->calendarArray[$date[1]][$date[0]]['is_holiday'] = TRUE;
				}
			}
			while (list($id, $event) = each($this->events))
			{
				$date = date('Y-m-d',$event['startdate']);
				$date = explode('-',$date);
				$this->calendarArray[intval($date[1])][intval($date[2])]['events'][] = $event;
			}
		}
		
	function pi_getLL($void) {
		// Names are not shown - void
	
	}

	function createHolidays ($lang) {
	
	$lang = strtolower($lang);
		//international christian holidays
		$this->holidays = array(
		'newyear' => "1.1.",
		'threekings' => "6.1.",
		'christmas25' => "25.12."
		);

		// Advent
		$start_date = mktime(0,0,0,12,24,$this->year);
		$weekday = date("w", $start_date);
		if ($weekday == 0) $weekday=6;
		$this->holidays['advent4'] = date("j.n.", ($start_date-($weekday*86400)));
		$this->holidays['advent3'] = date("j.n.", ($start_date-($weekday*86400)-604800));
		$this->holidays['advent2'] = date("j.n.", ($start_date-($weekday*86400)-1209600));
		$this->holidays['advent1'] = date("j.n.", ($start_date-($weekday*86400)-1814400));


		// Easter
		// Sometimes easter_date() is not available, that is why we use a fallback here.
		// I hope that easter_date() will be standardfunction on all PHP installations.
		// Also there is a offset from 50 Seconds here. Believe it or not, some PHP-Versions produce wrong
		// dates by adding a second here and there.
		$easter_arr = array(
		2004 => 1081634422,
		2005 => 1111878050,
		2006 => 1145138450,
		2007 => 1175983250,
		2008 => 1206226850,
		2009 => 1239487250,
		2010 => 1270332050
		);

		if (!function_exists('easter_date')) $easter = $easter_arr[$this->year];
		
		else $easter = easter_date($this->year);
		$this->holidays['easter'] = date("j.n.", $easter);
		$this->holidays['easterfr'] = date("j.n.", $easter-172800);
		$this->holidays['eastermo'] = date("j.n.", $easter+86400);

		//Pfingsten
		$pfingsten['day'] = date("d", $easter);
		$pfingsten['month'] = date("m", $easter);
		$pfingsten_date = mktime(0,0,0,$pfingsten['month'],$pfingsten['day']+49,$this->year);
		$this->holidays['pentacost'] = date("j.n.", $pfingsten_date);
		$this->holidays['pentacostmo'] = date("j.n.", ($pfingsten_date+86400));

		// local Holidays
		switch ($lang) {
			case 'de': // german holidays
			$this->holidays_fix = array(
			'mai' => "1.5.",
			'dteinheit' => "3.10.",
			'allerheilig' => "1.11.",
			'christmas26' => "26.12."
			);
			$this->holidays = array_merge($this->holidays,$this->holidays_fix);
			// Christi Himmelfahrt
			$himmelfahrt = mktime(0,0,0,$pfingsten['month'],$pfingsten['day']+39,$this->year);
			$this->holidays['christihf'] = date("j.n.", $himmelfahrt);

			// Fronleichnam
			$fronleichnam['day'] = date("d", $easter);
			$fronleichnam['month'] = date("m", $easter);
			$fronleichnam_date = mktime(0,0,0,$fronleichnam['month'],$fronleichnam['day']+60,$this->year);
			$this->holidays['fronleich'] = date("j.n.", $fronleichnam_date);

			break;
		}
	}

	function parseCalendar()
	{
		
		$content = '<style type="text/css">
<!--
td.holiday {  font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 10px; color: #CC3300; background-color: #CCCCCC}
td.sunday {  font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 10px; color: #CC3300; background-color: #CCCCCC}
td.past_weekday {  font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 10px; font-style: normal; font-weight: lighter}
td.calendarheading {  font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 12px; font-style: normal; font-weight: bold}

-->
</style>';
		$content .= $this->makelinks();
		$content .= '<table width="100%" border="1" cellspacing="0" cellpadding="0"><tr valign=\"middle\">';
		$os_month = intval(date('m',$this->conf['filters']['startdate']));
		for ($month=$os_month; $month<=$os_month+5; $month++) // monthline
		{
			$content .= '<td class=calendarheading>&nbsp;' . strftime('%B',mktime(0,0,0,$month,1,$this->year)) . '<br><img src=""clear.gif"" width="160" height="1"></td>';
		}
		$content .= '</tr>';
		for ($day=1; $day<=31; $day++)
		{
			$content .= '<tr valign="middle">';
			for ($month=$os_month; $month<=$os_month+5; $month++)
			{
				$content .= '<td>';

				$content .= $this->makeMyDay($this->calendarArray[$month][$day]);

				$content .= '</td>';
			}
			$content .= '</tr>';
		}
		$content .= '</table>';
		$content .= $this->makelinks();
		return $content;
	}
	
	function makelinks () {
	if (date('m',$this->conf['filters']['startdate']) == 1) {
		$year = date('Y',$this->conf['filters']['startdate'])-1;
		$month = 7;
	}
	else {
		$year = date('Y',$this->conf['filters']['startdate']);
		$month = 1;
		
	}
	$links = '<a href="index.php?id=' . $this->conf['general']['source_pidlist'] . '&month=' . $month . '&year=' . $year . '">' . strftime('%B',mktime(0,0,0,$month,1,$year)) . ' - ' . strftime('%B',mktime(0,0,0,$month+5,1,$year)) . ' ' . $year . '</a>&nbsp;&nbsp;';
	$year++;
	$links .= '<a href="index.php?id=' . $this->conf['general']['source_pidlist'] . '&month=' . $month . '&year=' . $year . '">' . strftime('%B',mktime(0,0,0,$month,1,$year)) . ' - ' . strftime('%B',mktime(0,0,0,$month+5,1,$year)) . ' ' . $year . '</a>';
	return $links;
}

	function makeMyDay($day_array) {
		
		$content = '<table border="0" width=100% cellspacing="0" cellpadding="0">'
		.'<tr>';
		
		$content .= '<td class=' . $day_array['style'] . '>&nbsp;' . $day_array['d_name']['no'] . '</td><td class=' . $day_array['style'] . '><img src="clear.gif" width=20></td>'
		.'<td class=' . $day_array['style'] . '>';
		
		if ($day_array['events']) //is there an event?
		{
			
			$content .= '<table border="0" cellspacing="0" cellpadding="0" align="right"><tr valign=bottom>';
			while (list(, $event) = each($day_array['events']))
			{
				$event['category'] = $this->session_vars[0]['category'][intval($event['category'])]['icon'] ? '../../../../uploads/tx_skcalendar/' . $this->session_vars[0]['category']['icon'] : '../ext_icon.gif';
				
				$content .= '<td>';
				if ($event['is_recurring'] || $event['is_span']) {
					$link = '<a href="index.php?id=' . $this->conf['general']['source_pidlist'] . '&month=' . $this->month . '&year=' . $this->year . '&edit=' . $event['uid'] . '">';
				}
				else {
					$params = '&edit[tx_skcalendar_event][' . $event['uid'] . ']=edit';
					$backPath = '../../../../typo3/';
					$requestUri=substr(t3lib_extMgm::extPath("sk_calendar"),strlen(PATH_site)).'cm1/index.php';
					$link = '<a href=# onclick="' . t3lib_BEfunc::editOnClick($params,$backPath) . '">';
				}
				$content .= $link . '<img src="' . $event['category'] . '" border=0 alt="' . $event['title'] . '" title="' . $event['title'] . '"></a><br></td>';
			}
			$content .= '</tr></table>';
		}
		$content .= '</td>';

		$content .= '</tr></table>';
		return $content;
	}
	
	function editSwitch($id) {
		$uid = explode('_',$id);
		if (strpos('span',$uid[1]) === FALSE) $kind = 're';
		else $kind = 'span';
		$exeption =  $uid[1];
		$uid = $uid[0];
			$content = 'Sie ndern ein wiederkehrendes Ereignis. Mchten Sie nur dieses Ereignis oder die ganze Ereignisserie bearbeiten?</strong>';
			$params = '&edit[tx_skcalendar_event][' . $uid . ']=edit';
			$backPath = '../../../../typo3/';
			$requestUri=substr(t3lib_extMgm::extPath("sk_calendar"),strlen(PATH_site)).'cm1/index.php';
			$content .= '<br><br><strong><a href=# onclick="' . t3lib_BEfunc::editOnClick($params,$backPath) . '">';
			$content .= 'Die ganze Ereignisserie ndern</a>&nbsp;&nbsp;&nbsp;';
			$params .= '&doexeption=' . $exeption;
			$content .= '<br><a href=# onclick="' . t3lib_BEfunc::editOnClick($params,$backPath) . '">';
			$content .= 'Nur dieses Ereignis ndern</a>';

		return $content;
	}

	
	}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/sk_calendar/cm1/class.tx_skcalendar_gridedit.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/sk_calendar/cm1/class.tx_skcalendar_gridedit.php']);
}
	?>