<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2006 Volker Biberger - Sitekick <info@sitekick.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * sk_calendar module cm1
 *
 * @author	Volker Biberger - Sitekick <info@sitekick.de>
 */

	// DEFAULT initialization of a module [BEGIN]
unset($MCONF);
require ('conf.php');
require ($BACK_PATH.'init.php');
require ($BACK_PATH.'template.php');

// Generate PATH_tslib
$path = PATH_t3lib;
$path = str_replace('t3lib/','',$path);
define('PATH_tslib',$path . 'typo3/sysext/cms/tslib/');

require_once(PATH_tslib.'class.tslib_pibase.php');
require_once(t3lib_extMgm::extPath('sk_calendar').'class.tx_skcalendar_selection.php');
require_once(t3lib_extMgm::extPath('sk_calendar').'pi1/class.tx_skcalendar_feengine.php');
require ('class.tx_skcalendar_gridedit.php');
$LANG->includeLLFile('EXT:sk_calendar/cm1/locallang.xml');
require_once (PATH_t3lib.'class.t3lib_scbase.php');
	// ....(But no access check here...)
	// DEFAULT initialization of a module [END]

			class tx_skcalendar_cm1 extends t3lib_SCbase {
				/**
 * Adds items to the ->MOD_MENU array. Used for the function menu selector.
 *
 * @return	[type]		...
 */
				function menuConfig()	{
					global $LANG;
// 					$this->MOD_MENU = Array (
// 						'function' => Array (
// 							'1' => $LANG->getLL('function1'),
// 							'2' => $LANG->getLL('function2'),
// 							'3' => $LANG->getLL('function3'),
// 						)
// 					);
					parent::menuConfig();
				}

				/**
 * Main function of the module. Write the content to 
 *
 * @return	[type]		...
 */
				function main()	{
					global $BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;

						// Draw the header.
					$this->doc = t3lib_div::makeInstance('mediumDoc');
					$this->doc->backPath = $BACK_PATH;
					$this->doc->form='<form action="" method="POST">';

					
					// Fake Pi for convenience
					$this->piVars = array_merge($_POST,$_GET);
					if (!$this->piVars['month']) {
						$this->piVars['month'] = (date('m') < 7) ? 1 : 7;
					
					}
					if (!$this->piVars['year']) $this->piVars['year'] = date('Y');


						// JavaScript
					$this->doc->JScode = '
						<script language="javascript" type="text/javascript">
							script_ended = 0;
							function jumpToUrl(URL)	{
								document.location = URL;
							}
						</script>
					';

					$this->pageinfo = t3lib_BEfunc::readPageAccess($this->id,$this->perms_clause);
					$access = is_array($this->pageinfo) ? 1 : 0;
					if (($this->id && $access) || ($BE_USER->user['admin'] && !$this->id))	{
						if ($BE_USER->user['admin'] && !$this->id)	{
							$this->pageinfo=array('title' => '[root-level]','uid'=>0,'pid'=>0);
						}

						$headerSection = $this->doc->getHeader('pages',$this->pageinfo,$this->pageinfo['_thePath']).'<br>'.$LANG->sL('LLL:EXT:lang/locallang_core.xml:labels.path').': '.t3lib_div::fixed_lgd_pre($this->pageinfo['_thePath'],50);

						$this->content.=$this->doc->startPage($LANG->getLL('title'));
						$this->content.=$this->doc->header($LANG->getLL('title'));
						$this->content.=$this->doc->spacer(5);
						$this->content.=$this->doc->section('',$this->doc->funcMenu($headerSection,t3lib_BEfunc::getFuncMenu($this->id,'SET[function]',$this->MOD_SETTINGS['function'],$this->MOD_MENU['function'])));
						$this->content.=$this->doc->divider(5);


						// Render content:
						$this->moduleContent();


						// ShortCut
						if ($BE_USER->mayMakeShortcut())	{
							$this->content.=$this->doc->spacer(20).$this->doc->section('',$this->doc->makeShortcutIcon('id',implode(',',array_keys($this->MOD_MENU)),$this->MCONF['name']));
						}
					}
					$this->content.=$this->doc->spacer(10);
				}

	/**
	 * [Describe function...]
	 *
	 * @return	[type]		...
	 */
				function printContent()	{

					$this->content.=$this->doc->endPage();
					echo $this->content;
				}

	/**
	 * [Describe function...]
	 *
	 * @return	[type]		...
	 */
				function moduleContent()	{
					$content = $this->gridCalendar();
					$this->content.=$this->doc->section('VCE Grid Edit:',$content,0,1);
				}
				
				function gridCalendar() {
				
					// Setup system
					$month = $this->piVars['month'];
					$year = $this->piVars['year'];
					$end = mktime(0,0,0,$offset_temp[0],31,$offset_temp[2]);
					$this->conf['filters']['startdate'] = mktime(0,0,0,$month,1,$year);
					$this->conf['filters']['enddate'] = mktime(0,0,0,$month+5,31,$year);
					$this->conf['general']['source_pidlist'] = $this->piVars['id'];
					$this->conf['filters']['sys_language_uid'] = intval($this->piVars['lang']);
					$this->conf['offset'] = $this->conf['filters']['startdate'];
					$this->conf['filters']['category'] = array();
					$this->conf['filters']['targetgroup'] = array();
					$this->conf['filters']['location'] = array();
					$this->conf['filters']['organizer'] = array();

					
					// Do selection
					$selection = new tx_skcalendar_selection_be($this->conf);
					$selection->getResults();
					$selection->close();

					// Do calendar
					$calendar = new tx_skcalendar_gridedit($selection,$this->conf);
					if (!$this->piVars['edit']) {
						$calendar->createHolidays('de');
 						$calendar->createCalendar();
 						$content = $calendar->parseCalendar();
 					}
 					else $content = $calendar->editSwitch($this->piVars['edit']);

					return $content;
				}
			}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/sk_calendar/cm1/index.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/sk_calendar/cm1/index.php']);
}




// Make instance:
$SOBE = t3lib_div::makeInstance('tx_skcalendar_cm1');
$SOBE->init();


$SOBE->main();
$SOBE->printContent();

?>