<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2004 Volker Biberger / sitekick.de <info@sitekick.de>
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/


// Manage HTML-View of Data

class tx_skcalendar_boxview extends tx_skcalendar_htmlview {


	function tx_skcalendar_boxview($container,$conf) {
		// calls mothership
		$this->tx_skcalendar_htmlview($container,$conf);
	}

	function parseCalendar() {
		$act_date = $this->offset;

				// register subparts
		$subparts = array(
			'BOX_VIEW_ITEM',
			'BOX_VIEW_NOENTRY',
			'BOX_VIEW_DAYWRAP',
			'BOX_VIEW_NAVIGATION',
			'BOX_VIEW_WHOLEWRAP',
			);
		$this->template->registerSubparts($subparts);

		
		
		$this->content = '';
		while ($act_date < $this->conf['filters']['enddate']) {
			$m = intval(date('m',$act_date));
			$d = intval(date('d',$act_date));
			if ($this->calendarArray[$m][$d]['events']) {	

				$temp['date'] = $act_date;
				while (list(,$data) = each($this->calendarArray[$m][$d]['events'])) {
					$temp['style'] = '';
					$temp['style'] .= $data['category'] ? ' list_cat' . $data['category']['uid'] : '';
					$temp['style'] .= $data['targetgroup'] ? ' list_tar' . $data['targetgroup']['uid'] : '';
					$temp['style'] .= $data['location'] ? ' list_loc' . $data['location']['uid'] : '';
					$temp['style'] .= $data['organizer'] ? ' list_org' . $data['organizer']['uid'] : '';
					
					unset($linktext);
					if ($data['start_time']) {
							$hours = floor($data['start_time']/3600);
							$minutes = ($data['start_time']%3600)/60; // modulus
							if ($minutes < 10) $minutes = '0' . $minutes;
							$linktext =  $hours . ':' . $minutes . ' ';
					}
					$linktext .= $data['title'];
					
					$temp['linktext'] = $linktext;

					$this->template->setItem($data);
					$this->template->setTempData($temp);
					$this->template->getSubpart('BOX_VIEW_ITEM');
					$temp['wrapit_BOX_VIEW_ITEM'] .= $this->template->parseTemplate();	
				}
				$this->template->setTempData($temp);
				$this->template->getSubpart('BOX_VIEW_DAYWRAP');
				$c_result .= $this->template->parseTemplate();
				unset($temp['wrapit_BOX_VIEW_ITEM']);

			}
			
			$act_date = $this->addDaysToTimestamp($act_date,1);

		}
		if ($c_result) $content .= $c_result;
		else {
			$this->template->getSubpart('BOX_VIEW_NOENTRY');
			$content .= $this->template->parseTemplate();
		}
		$temp['wrapit_BOX_VIEW_DAYWRAP'] = $content;
		
		// get Navigation
		$this->template->setTempData($this->makeNavigation());
		$this->template->getSubpart('BOX_VIEW_NAVIGATION');
		$temp['wrapit_BOX_VIEW_NAVIGATION'] = $this->template->parseTemplate();
		
		// wrap whole thing
		$this->template->setTempData($temp);
		$this->template->getSubpart('BOX_VIEW_WHOLEWRAP');
		$this->content = $this->template->parseTemplate();
	}
	
	function makeNavigation() {
		$next = $this->prepareTypolink();
		$back = $this->prepareTypolink();
		$next['tx_skcalendar_pi1[offset]'] = $this->addDaysToTimestamp($this->conf['filters']['startdate'],$this->conf['box']['range']);
		$back['tx_skcalendar_pi1[offset]'] = $this->addDaysToTimestamp($this->conf['filters']['startdate'],-$this->conf['box']['range']);
		$navi['backlink'] = '<a href="' . $GLOBALS["TSFE"]->cObj->getTypoLink_URL($GLOBALS["TSFE"]->id,$back) . '"> << </a>';
		$navi['nextlink'] = '<a href="' . $GLOBALS["TSFE"]->cObj->getTypoLink_URL($GLOBALS["TSFE"]->id,$next) . '"> >> </a>';
		return $navi;
		
	}
}

if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/sk_calendar/pi1/class.tx_skcalendar_boxview.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/sk_calendar/pi1/class.tx_skcalendar_boxview.php"]);
}
