<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2004 Volker Biberger / sitekick.de <info@sitekick.de>
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more DAYs.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/


// Manage HTML-View of Data

class tx_skcalendar_dayview extends tx_skcalendar_htmlview {
	var $showID;

	function tx_skcalendar_dayview($container,$conf) {
		// calls mothership
		$this->tx_skcalendar_htmlview($container,$conf);
	}

	function parseCalendar() {
	
	// register subparts
		$subparts = array(
			'DAY_VIEW_LOCATION',
			'DAY_VIEW_ORGANIZER',
			'DAY_VIEW_TARGETGROUP',
			//nderung Tippfehler johpie
			'DAY_VIEW_CATEGORY',
			'DAY_VIEW_ITEM',
			'DAY_VIEW_NAVIGATION',
			'DAY_VIEW_WHOLEWRAP',
		);
		$this->template->registerSubparts($subparts);

	
	// show data
		
			$m = intval(date('m',$this->offset));
			$d = intval(date('d',$this->offset));
			//nderung damit das Datum auch in der Datailansicht angezeigt wird johpie
			$temp['date'] = $this->offset;
			if ($this->calendarArray[$m][$d]['events']) {
			
			while (list(,$data) = each($this->calendarArray[$m][$d]['events'])) {
					$data['description'] = $this->myCobj->stdWrap($data['description'],$this->conf['general']['rtefield_stdWrap']);
					// Location
					$this->template->setItem($data);
					$this->template->getSubpart('DAY_VIEW_LOCATION');
					$temp['wrapit_DAY_VIEW_LOCATION'] = $data['location'] ? $this->template->parseTemplate() : '';

					$this->template->setItem($data);
					$this->template->getSubpart('DAY_VIEW_ORGANIZER');
					$temp['wrapit_DAY_VIEW_ORGANIZER'] = $data['organizer'] ? $this->template->parseTemplate() : '';
					
					$this->template->setItem($data);
					$this->template->getSubpart('DAY_VIEW_CATEGORY');
					$temp['wrapit_DAY_VIEW_CATEGORY'] = $data['category'] ? $this->template->parseTemplate() : '';

					$this->template->setItem($data);
					$this->template->getSubpart('DAY_VIEW_TARGETGROUP');
					$temp['wrapit_DAY_VIEW_TARGETGROUP'] = $data['targetgroup'] ? $this->template->parseTemplate() : '';
					
					$this->template->setTempData($temp);
					$this->template->setItem($data);
					$this->template->getSubpart('DAY_VIEW_ITEM');
					$content .= $this->template->parseTemplate();
				}
			}
	//	debug($content);
		
	// Navigation
	$temp = $this->makeNavigation();
	$temp['date'] = $this->offset;
	$this->template->setTempData($temp);

	$this->template->getSubpart('DAY_VIEW_NAVIGATION');
	$temp['wrapit_DAY_VIEW_NAVIGATION'] = $this->template->parseTemplate();


	// Wrap
	$temp['wrapit_DAY_VIEW_ITEM'] = $content;
	$this->template->setTempData($temp);
	$this->template->getSubpart('DAY_VIEW_WHOLEWRAP');
	$this->content .= $this->template->parseTemplate();

	}
	
	function makeNavigation() {
		$offset = date('m',$this->offset);
		$next = $this->prepareTypolink();
		$back = $this->prepareTypolink();
		$nextyear = $this->prepareTypolink();
		$backyear = $this->prepareTypolink();
		
		$next['tx_skcalendar_pi1[offset]'] = mktime(0,0,0,$offset+1,1,$this->year);
		$back['tx_skcalendar_pi1[offset]'] = mktime(0,0,0,$offset-1,1,$this->year);
		$nextyear['tx_skcalendar_pi1[offset]'] = mktime(0,0,0,$offset,1,$this->year+1);
		$backyear['tx_skcalendar_pi1[offset]'] = mktime(0,0,0,$offset,1,$this->year-1);
		$next['tx_skcalendar_pi1[view]'] = 'listmonth';
		$back['tx_skcalendar_pi1[view]'] = 'listmonth';
		$nextyear['tx_skcalendar_pi1[view]'] = 'listmonth';
		$backyear['tx_skcalendar_pi1[view]'] = 'listmonth';

		$navi['backlinkyear'] = '<a href="' . $GLOBALS["TSFE"]->cObj->getTypoLink_URL($GLOBALS["TSFE"]->id,$backyear) . '"> << </a>';
		$navi['nextlinkyear'] = '<a href="' . $GLOBALS["TSFE"]->cObj->getTypoLink_URL($GLOBALS["TSFE"]->id,$nextyear) . '"> >></a>';

		$navi['backlink'] = '<a href="' . $GLOBALS["TSFE"]->cObj->getTypoLink_URL($GLOBALS["TSFE"]->id,$back) . '"> << </a>';
		$navi['nextlink'] = '<a href="' . $GLOBALS["TSFE"]->cObj->getTypoLink_URL($GLOBALS["TSFE"]->id,$next) . '"> >> </a>';
		$monthlink = $this->prepareTypolink();
		$monthlink['tx_skcalendar_pi1[view]'] = 'listmonth';
		for ($i=1; $i<=12; $i++) {
			$monthlink['tx_skcalendar_pi1[offset]'] = mktime(0,0,0,$i,1,$this->year);
			$navi['month_navi'] .= '<td';
			$navi['month_navi'] .= ($i==$offset) ? ' class=monthname' : '';
			$navi['month_navi'] .= '><a href="' . $GLOBALS["TSFE"]->cObj->getTypoLink_URL($GLOBALS["TSFE"]->id,$monthlink) . '"> ' . strtoupper(strftime('%b',$monthlink['tx_skcalendar_pi1[offset]'])) . '</a></td>';
			
		}
		return $navi;
	}

}

if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/sk_calendar/pi1/class.tx_skcalendar_dayview.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/sk_calendar/pi1/class.tx_skcalendar_dayview.php"]);
}
