<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2003 Volker Biberger (info@sitekick.de)
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
* Frontendengine Provides basic functions for all other forms of displaying or providing data
*
* @author	Volker Biberger <info@sitekick.de>
*/

class tx_skcalendar_feengine extends tslib_pibase {
	var $prefixId = 'tx_skcalendar_pi1';		// Same as class name
	var $scriptRelPath = "pi1/class.tx_skcalendar_pi1.php";	// Path to this script relative to the extension dir.
	var $extKey = "sk_calendar";	// The extension key.
	var $categories = array();
	var $targetgroups = array();
	var $organizers = array();
	var $locations = array();
	var $holidays = array();
	var $conf;
	var $results;
	var $view;
	var $events;
	var $offset;
	var $fromdate;
	var $todate;
	var $year;
	var $content;
	var $myCobj;
	
	function tx_skcalendar_feengine ($results,$conf) {
	$this->conf = $conf;
	$this->pi_setPiVarDefaults();
	$this->LLkey = $conf['system']['LLkey'];
	$this->pi_loadLL();
	$this->pi_USER_INT_obj=1;	// Configuring so caching is not expected. This value means that no cHash params are ever set. We do this, because it's a USER_INT object!
	$this->myCobj = t3lib_div::makeInstance('tslib_cObj');
	
	if (!$conf['general']['target_pid']) $this->conf['general']['target_pid'] = $GLOBALS["TSFE"]->id;
	$this->view = $conf['general']['view'];
	$this->events = $results;

	// Get sessiondata
	$this->session_vars = (TYPO3_MODE == 'FE') ? $GLOBALS["TSFE"]->fe_user->getKey('ses','tx_skcalendar') : $GLOBALS["BE_USER"]->getSessionData('tx_skcalendar');	
	$this->categories = $this->session_vars[$this->conf['filters']['sys_language_uid']]['category']; // ?
	$this->locations = $this->session_vars[$this->conf['filters']['sys_language_uid']]['location'];
	$this->organizers = $this->session_vars[$this->conf['filters']['sys_language_uid']]['organizer'];
	$this->targetgroups = $this->session_vars[$this->conf['filters']['sys_language_uid']]['targetgroup'];
	$this->offset = $this->conf['offset'];
	$this->year = date('Y',$this->offset);

}

	function createHolidays ($lang) {
	
	$lang = strtolower($lang);
		//international christian holidays
		$this->holidays = array(
		'newyear' => "1.1.",
		'threekings' => "6.1.",
		'christmas25' => "25.12."
		);

		// Advent
		$start_date = mktime(0,0,0,12,24,$this->year);
		$weekday = date("w", $start_date);
		$this->holidays['advent4'] = date("j.n.", ($start_date-($weekday*86400)));
		$this->holidays['advent3'] = date("j.n.", ($start_date-($weekday*86400)-604800));
		$this->holidays['advent2'] = date("j.n.", ($start_date-($weekday*86400)-1209600));
		$this->holidays['advent1'] = date("j.n.", ($start_date-($weekday*86400)-1814400));


		// Easter
		// Sometimes easter_date() is not available, that is why we use a fallback here.
		// I hope that easter_date() will be standardfunction on all PHP installations.
		// Also there is a offset from 50 Seconds here. Believe it or not, some PHP-Versions produce wrong
		// dates by adding a second here and there.
		$easter_arr = array(
		2004 => 1081634422,
		2005 => 1111878050,
		2006 => 1145138450,
		2007 => 1175983250,
		2008 => 1206226850,
		2009 => 1239487250,
		2010 => 1270332050
		);

		if (!function_exists('easter_date')) $easter = $easter_arr[$this->year];
		
		else $easter = easter_date($this->year);
		$this->holidays['easter'] = date("j.n.", $easter);
		$this->holidays['easterfr'] = date("j.n.", $easter-172800);
		$this->holidays['eastermo'] = date("j.n.", $easter+86400);

		//Pfingsten
		$pfingsten['day'] = date("d", $easter);
		$pfingsten['month'] = date("m", $easter);
		$pfingsten_date = mktime(0,0,0,$pfingsten['month'],$pfingsten['day']+49,$this->year);
		$this->holidays['pentacost'] = date("j.n.", $pfingsten_date);
		$this->holidays['pentacostmo'] = date("j.n.", ($pfingsten_date+86400));

		// local Holidays
		switch ($lang) {
			case 'de': // german holidays
			$this->holidays_fix = array(
			'mai' => "1.5.",
			'dteinheit' => "3.10.",
			'allerheilig' => "1.11.",
			'christmas26' => "26.12."
			);
			$this->holidays = array_merge($this->holidays,$this->holidays_fix);
			// Christi Himmelfahrt
			$himmelfahrt = mktime(0,0,0,$pfingsten['month'],$pfingsten['day']+39,$this->year);
			$this->holidays['christihf'] = date("j.n.", $himmelfahrt);

			// Fronleichnam
			$fronleichnam['day'] = date("d", $easter);
			$fronleichnam['month'] = date("m", $easter);
			$fronleichnam_date = mktime(0,0,0,$fronleichnam['month'],$fronleichnam['day']+60,$this->year);
			$this->holidays['fronleich'] = date("j.n.", $fronleichnam_date);

			break;
		}
	}
	
	function getMonthName($month) {
		$date_unix = mktime(0,0,0,$month,1,$year);
		$name = strftime("%B",$date_unix);
		return $name;
	}

	function getCategory($catid,$field=FALSE) {
 		/*echo $field.'<br>'.$catid;
		echo t3lib_div::view_array($catid);
		echo t3lib_div::view_array($this->categories);*/
		if ($field) 
			return $this->categories[$catid][$field];
		else 
			return $this->categories[$catid];
	}

	function getLocation($locid,$field=FALSE) {
		if ($field) return $this->locations[$locid][$field];
		else return $this->locations[$locid];
	}

	function getOrganizer($orga,$field=FALSE) {
		if ($field) return $this->organizers[$orga][$field];
		else return $this->organizers[$orga];
	}

	function getTargetgroup($target,$field=FALSE) {
		if ($field) return $this->targetgroups[$target][$field];
		else return $this->targetgroups[$target];
	}
	
			/**
		* @return void
		* @desc create calendararray
		*/
		function createCalendar () {
			$from_m = intval(date('m',$this->conf['filters']['startdate']));
			$to_m = intval(date('m',$this->conf['filters']['enddate']));
			$from_y = intval(date('Y',$this->conf['filters']['startdate']));
			$to_y = intval(date('Y',$this->conf['filters']['enddate']));
			
			//nderung damit auch bei Thumbs der Jahrwechsel mit erfolgt.
			$to_m = $to_m + ($to_y - $from_y) * 12;

			// Probleme beim Jahreswechsel
			//if ($from_m == 12 && $to_m == 1) $to_m = 13;
			
			// forming the basic calendar array with the form $calendar[month][day]
			$year = $this->year; // might change
			for ($temp=$from_m; $temp<=$to_m; $temp++)
			{
				if ($temp == 13) {
					$temp = 1;
					$to_m -=12;
					$year++;
				}
				
				$date_unix = mktime(0,0,0,$temp,1,$year);
				//$this->content .= date('d.m.Y',$date_unix) . '<br>';
				$now = mktime(0,0,0);
				$count_days = date("t",$date_unix);
				for ($day=1; $day<=$count_days; $day++)
				{
					$date_unix = mktime(0,0,0,$temp,$day,$year);
					$this->calendarArray[$temp][$day]['d_ts'] = $date_unix;
					$this->calendarArray[$temp][$day]['d_name']['no'] = strftime("%e",$date_unix);
					if (!$this->calendarArray[$temp][$day]['d_name']['no']) $this->calendarArray[$temp][$day]['d_name']['no'] = strftime("%d",$date_unix); 
					$this->calendarArray[$temp][$day]['d_name']['short'] = strftime("%a",$date_unix);
					$this->calendarArray[$temp][$day]['d_name']['initials'] = substr(strftime("%a",$date_unix),0,2);
					$this->calendarArray[$temp][$day]['d_name']['long'] = strftime("%A",$date_unix);
					date('d');
					if (date("w",$date_unix)==0 || date("w",$date_unix)==6) $this->calendarArray[$temp][$day]['style'] ='weekend'; // sunday
					else $this->calendarArray[$temp][$day]['style'] = 'weekday';
					if ($date_unix < $now) $this->calendarArray[$temp][$day]['style'] .= ' past_weekday';					$this->calendarArray[$temp][$day]['style'] .= ' ' . date('D',$date_unix);
				}
			}
			while (list($name,$date) = each($this->holidays))
			{
				$date = explode('.',$date);
				if ($this->calendarArray[$date[1]]) {
					$this->calendarArray[$date[1]][$date[0]]['d_name']['short'] = $this->pi_getLL($name);
					$this->calendarArray[$date[1]][$date[0]]['d_name']['long'] = $this->pi_getLL($name);
					$this->calendarArray[$date[1]][$date[0]]['style']='holiday';
					$this->calendarArray[$date[1]][$date[0]]['is_holiday'] = TRUE;
				}
			}
			while (list($id, $event) = each($this->events))
			{
				$date = date('Y-m-d',$event['startdate']);
				$date = explode('-',$date);
				$this->calendarArray[intval($date[1])][intval($date[2])]['events'][] = $event;
			}
		}


	function addDaysToTimestamp($tstamp,$days) {
		$tstamp = date('m-d-Y',$tstamp);
		$tstamp = explode('-',$tstamp);
		$tstamp = mktime(0,0,0,$tstamp[0],$tstamp[1]+$days,$tstamp[2]);
		return $tstamp;

	}
	
	function addMonthsToTimestamp($tstamp,$months) {
		$tstamp = date('m-d-Y',$tstamp);
		$tstamp = explode('-',$tstamp);
		$tstamp = mktime(0,0,0,$tstamp[0]+months,$tstamp[1],$tstamp[2]);
		return $tstamp;
	}


	function setRange($offset,$todate) {
		$this->fromdate = $offset;
		$this->todate = $todate;
	}
}

if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/sk_calendar/pi1/class.tx_skcalendar_feengine.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/sk_calendar/pi1/class.tx_skcalendar_feengine.php"]);
}

?>