<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2004 Volker Biberger / sitekick.de <info@sitekick.de>
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/


// Manage HTML-View of Data

class tx_skcalendar_listmonthview extends tx_skcalendar_htmlview {

	function tx_skcalendar_listmonthview($container,$conf) {
		// calls mothership
		
		$this->tx_skcalendar_htmlview($container,$conf);
	}

	function parseCalendar() {
		$month = intval(date('m',$this->offset));
		
		// register subparts
		$subparts = array(
			'LISTMONTH_VIEW_ITEM',
			'LISTMONTH_VIEW_ITEM_SPAN',
			'LISTMONTH_VIEW_NAVIGATION',
			'LISTMONTH_VIEW_WHOLEWRAP');
		$this->template->registerSubparts($subparts);
		
		if ($this->conf['general']['showlinks']) $this->makeLinks();
		if ($this->conf['general']['showfilters']) $this->makeFilters();
		
		// amount weeks
		$days = date('t',mktime(0,0,0,$month,1,$this->year));
		
		for ($d=1;$d<=$days;$d++) {
				$temp['style'] = 'month_' . $this->calendarArray[$month][$d]['style'];
				if ($this->calendarArray[$month][$d]['d_ts']) $temp['timestamp'] = $this->calendarArray[$month][$d]['d_ts'];
				if ($this->calendarArray[$month][$d]['events'] && !$span) { // Spaning events prevent other events
					while (list(,$data) = each($this->calendarArray[$month][$d]['events'])) {
						// add style information
						$temp['style'] .= $data['category'] ? ' listmonth_cat' . $data['category']['uid'] : '';
						$temp['style'] .= $data['targetgroup'] ? ' listmonth_tar' . $data['targetgroup']['uid'] : '';
						$temp['style'] .= $data['location'] ? ' listmonth_loc' . $data['location']['uid'] : '';
						$temp['style'] .= $data['organizer'] ? ' listmonth_org' . $data['organizer']['uid'] : '';
						$temp['style'] .= ' dayactive';
						$linktext = $this->pi_getLL('more');
						$temp['linktext'] = $linktext;
						$this->template->setItem($data);
						$temp['name'] = $this->calendarArray[$month][$d]['d_name']['initials'] . '</td><td class="' . $temp['style'] . '">' . $this->calendarArray[$month][$d]['d_name']['no'];
						unset($this->calendarArray[$month][$d]['d_name']['initials']);
						unset($this->calendarArray[$month][$d]['d_name']['no']);

						$this->template->setTempData($temp);
						$this->template->getSubpart('LISTMONTH_VIEW_ITEM');
						if ($data['spancount']) {
							$span = $data['spancount']-1;
							$style_temp = $temp['style'];
						}
					$content_day .= $this->template->parseTemplate();
					}
				}
				else {
					if ($span) $temp['style'] = $style_temp;
					$temp['name'] = $this->calendarArray[$month][$d]['d_name']['initials'] . '</td><td class="' . $temp['style'] . '">' . $this->calendarArray[$month][$d]['d_name']['no'];
					if ($this->calendarArray[$month][$d]['is_holiday']) {
						unset($data);
						$data['title'] = $this->calendarArray[$month][$d]['d_name']['long'];
						$this->template->setItem($data);
					}
	
					$this->template->setTempData($temp);
					if (!$span) $this->template->getSubpart('LISTMONTH_VIEW_ITEM');
					else {
						$this->template->getSubpart('LISTMONTH_VIEW_ITEM_SPAN');
						$span--;
					}
					$content_day .= $this->template->parseTemplate();
				}
				// Make my day
				$content_row .= $content_day;
				unset ($content_day);
			}
		$temp['wrapit_LISTMONTH_VIEW_ITEM'] = $content_row;
		
		// get Navigation
		$this->template->setTempData($this->makeNavigation());
		$this->template->getSubpart('LISTMONTH_VIEW_NAVIGATION');
		$temp['wrapit_LISTMONTH_VIEW_NAVIGATION'] = $content . $this->template->parseTemplate();
		
		// wrap whole thing
		$this->template->setTempData($temp);
		$this->template->getSubpart('LISTMONTH_VIEW_WHOLEWRAP');
		$this->content .= $this->template->parseTemplate();
	}

	function makeNavigation() {
		$offset = date('m',$this->offset);
		$next = $this->prepareTypolink();
		$back = $this->prepareTypolink();
		$nextyear = $this->prepareTypolink();
		$backyear = $this->prepareTypolink();
		
		$next['tx_skcalendar_pi1[offset]'] = mktime(0,0,0,$offset+1,1,$this->year);
		$back['tx_skcalendar_pi1[offset]'] = mktime(0,0,0,$offset-1,1,$this->year);
		$nextyear['tx_skcalendar_pi1[offset]'] = mktime(0,0,0,$offset,1,$this->year+1);
		$backyear['tx_skcalendar_pi1[offset]'] = mktime(0,0,0,$offset,1,$this->year-1);

		$navi['backlinkyear'] = '<a href="' . $GLOBALS["TSFE"]->cObj->getTypoLink_URL($GLOBALS["TSFE"]->id,$backyear) . '"> << </a>';
		$navi['nextlinkyear'] = '<a href="' . $GLOBALS["TSFE"]->cObj->getTypoLink_URL($GLOBALS["TSFE"]->id,$nextyear) . '"> >></a>';

		$navi['backlink'] = '<a href="' . $GLOBALS["TSFE"]->cObj->getTypoLink_URL($GLOBALS["TSFE"]->id,$back) . '"> << </a>';
		$navi['nextlink'] = '<a href="' . $GLOBALS["TSFE"]->cObj->getTypoLink_URL($GLOBALS["TSFE"]->id,$next) . '"> >> </a>';
		$monthlink = $this->prepareTypolink();
		for ($i=1; $i<=12; $i++) {
			$monthlink['tx_skcalendar_pi1[offset]'] = mktime(0,0,0,$i,1,$this->year);
			//nderung zur Navigation von johpie
			$tmp_month = '<a href="' . $GLOBALS["TSFE"]->cObj->getTypoLink_URL($GLOBALS["TSFE"]->id,$monthlink) . '"> ' . strtoupper(strftime('%b',$monthlink['tx_skcalendar_pi1[offset]'])) . '</a>';
			if ($i==$offset)
				$navi['month_navi'] .= $GLOBALS["TSFE"]->cObj->stdWrap($tmp_month, $this->conf['listmonthview']['nav']['aktmonth']);
			  else
				$navi['month_navi'] .= $GLOBALS["TSFE"]->cObj->stdWrap($tmp_month, $this->conf['listmonthview']['nav']['month']);

			/*$navi['month_navi'] .= '<td';
			$navi['month_navi'] .= ($i==$offset) ? ' class=monthname' : '';
			$navi['month_navi'] .= '><a href="' . $GLOBALS["TSFE"]->cObj->getTypoLink_URL($GLOBALS["TSFE"]->id,$monthlink) . '"> ' . strtoupper(strftime('%b',$monthlink['tx_skcalendar_pi1[offset]'])) . '</a></td>';*/
			
		}
		return $navi;
	}
}

if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/sk_calendar/pi1/class.tx_skcalendar_listmonthview.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/sk_calendar/pi1/class.tx_skcalendar_listmonthview.php"]);
}
