<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2006 Volker Biberger - Sitekick <info@sitekick.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Plugin 'VCE Calendar' for the 'sk_calendar' extension.
 *
 * @author	Volker Biberger - Sitekick <info@sitekick.de>
 */


require_once(PATH_tslib.'class.tslib_pibase.php');
require_once(t3lib_extMgm::extPath('sk_calendar').'class.tx_skcalendar_selection.php');
require_once(t3lib_extMgm::extPath('sk_calendar').'pi1/class.tx_skcalendar_feengine.php');
require_once(t3lib_extMgm::extPath('sk_calendar').'pi1/class.tx_skcalendar_htmlview.php');

class tx_skcalendar_pi1 extends tslib_pibase {
	var $prefixId = 'tx_skcalendar_pi1';		// Same as class name
	var $scriptRelPath = 'pi1/class.tx_skcalendar_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey = 'sk_calendar';	// The extension key.
	
	/**
	 * The main method of the PlugIn
	 *
	 * @param	string		$content: The PlugIn content
	 * @param	array		$conf: The PlugIn configuration
	 * @return	The content that is displayed on the website
	 */
	function main($content,$conf)	{
		$this->TSconf=$conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
		$this->pi_USER_INT_obj=1;	// Configuring so caching is not expected. This value means that no cHash params are ever set. We do this, because it's a USER_INT object!
		
		$this->default_settings();
		$this->user_settings();
		// initiate selection
		
		$selection = new tx_skcalendar_selection_fe($this->conf);
		
		if ($this->conf['general']['view'] == 'upcoming' || $this->conf['general']['view'] == 'box') $selection->recurr_events = FALSE;
		
		$selection->getResults();
		$selection->close();
		// Display Results
		switch($this->conf['general']['view']) {
			case 'week':
			$calendar = new tx_skcalendar_weekview($selection->results,$this->conf);
			break;

			case 'box';
			$calendar = new tx_skcalendar_boxview($selection->results,$this->conf);
			break;

			case 'day':
			$calendar = new tx_skcalendar_dayview($selection->results,$this->conf);
			break;

			case 'month':
			$calendar = new tx_skcalendar_monthview($selection->results,$this->conf);
			$calendar->createHolidays($this->conf['system']['LLkey']);
			break;

			case 'listmonth':
			$calendar = new tx_skcalendar_listmonthview($selection->results,$this->conf);
			$calendar->createHolidays($this->conf['system']['LLkey']);
			break;

			case 'thumbmonth':
			$calendar = new tx_skcalendar_thumbmonthview($selection->results,$this->conf);
		//	$calendar = new tx_skcalendar_thumbmonthview(array(),$this->conf);
			$calendar->createHolidays($this->conf['system']['LLkey']);
			break;

			case 'yearview':
			$calendar = new tx_skcalendar_yearview($selection->results,$this->conf);
			$calendar->createHolidays($this->conf['system']['LLkey']);
			break;

			case 'detail';
			$calendar = new tx_skcalendar_detailview($selection->results,$this->conf);
			break;

			case 'list';
			$calendar = new tx_skcalendar_listview($selection->results,$this->conf);
			break;

			case 'archive';
			$calendar = new tx_skcalendar_archiveview($selection->results,$this->conf);
			break;
	
			case 'upcoming';
			$calendar = new tx_skcalendar_upcomingview($selection->results,$this->conf);
			break;
			
			default: 
			// Bail out
			$content .= 'View "' . $this->conf['general']['view'] . '" not implemented!';
			return $this->pi_wrapInBaseClass($content);
		
		}
		$calendar->createCalendar();
		$calendar->parseCalendar();

		return $this->pi_wrapInBaseClass($calendar->content);
	}
	
	
	// This function sets Defaults by plugin or TS
	function default_settings() {
	
		// get plugin-Settings
		$this->pi_initPIflexForm();
		$this->conf = ARRAY(
			'general' => array(
				'showlinks' => $this->pi_getFFvalue($this->cObj->data['pi_flexform'],'showlinks','sDEF'),
				'keep_view' => $this->pi_getFFvalue($this->cObj->data['pi_flexform'],'keep_view','sDEF'),
				'view' => $this->pi_getFFvalue($this->cObj->data['pi_flexform'],'default_view','sDEF'),
				'source_pid' => $this->pi_getFFvalue($this->cObj->data['pi_flexform'],'source_pid','sDEF'),
				'detail_pid' => $this->pi_getFFvalue($this->cObj->data['pi_flexform'],'detail_pid','sDEF'),
				'source_recursion' => $this->pi_getFFvalue($this->cObj->data['pi_flexform'],'source_recursion','sDEF'),
				'htmltemplate' => $this->pi_getFFvalue($this->cObj->data['pi_flexform'],'html_template','sDEF'),
				'pdftemplate' => $this->pi_getFFvalue($this->cObj->data['pi_flexform'],'pdf_template','sDEF'),
				'showfilters' => $this->pi_getFFvalue($this->cObj->data['pi_flexform'],'showfilters','sDEF'),
				'rtefield_stdWrap' => $this->TSconf['general.']['rtefield_stdWrap.'], // for RTE
				),
			'box' => array(
				'range' => $this->pi_getFFvalue($this->cObj->data['pi_flexform'],'boxrange','s_view'),
				),
			'thumbmonth' => array(
				'thumbmonths' => $this->pi_getFFvalue($this->cObj->data['pi_flexform'],'thumbmonths','s_view'),
				),
			'upcoming' => array(
				'range' => $this->pi_getFFvalue($this->cObj->data['pi_flexform'],'upcomingrange','s_view'),
				),
			'list' => array(
				'limit' => $this->pi_getFFvalue($this->cObj->data['pi_flexform'],'listrange','s_view'),
				'filter_month' => $this->pi_getFFvalue($this->cObj->data['pi_flexform'],'listmonths','s_view'),
				),
			'filters' => array(
				'showsearch' => $this->pi_getFFvalue($this->cObj->data['pi_flexform'],'showsearch','s_filters'),
				'showcat' => $this->pi_getFFvalue($this->cObj->data['pi_flexform'],'showcat','s_filters'),
				'showdate' => $this->pi_getFFvalue($this->cObj->data['pi_flexform'],'showdate','s_filters'),
				'showloc' => $this->pi_getFFvalue($this->cObj->data['pi_flexform'],'showloc','s_filters'),
				'showorg' => $this->pi_getFFvalue($this->cObj->data['pi_flexform'],'showorg','s_filters'),
				'showtar' => $this->pi_getFFvalue($this->cObj->data['pi_flexform'],'showtar','s_filters'),
				),
		);
		
		// defaultvalues
		if (!$this->conf['box']['range']) $this->conf['box']['range'] = $this->TSconf['box.']['range'];
		if (!$this->conf['thumbmonth']['thumbmonths']) $this->conf['thumbmonth']['thumbmonths'] = $this->TSconf['thumbmonth.']['thumbmonths'];
		if (!$this->conf['general']['source_pid']) $this->conf['general']['source_pid'] = $GLOBALS["TSFE"]->id;
		$this->conf['general']['source_pidlist'] = $this->pi_getPidList($this->conf['general']['source_pid'],$this->conf['general']['source_recursion']);
		if (!$this->conf['upcoming']['range']) $this->conf['upcoming']['range']= $this->TSconf['upcoming.']['range'];
		if (!$this->conf['list']['limit']) $this->conf['list']['limit'] = $this->TSconf['list.']['limit'];
		
		if (!$this->conf['general']['htmltemplate']) $this->conf['general']['htmltemplate'] = $this->TSconf['general.']['htmltemplate'];
		else $this->conf['general']['htmltemplate'] = 'uploads/tx_skcalendar/' . $this->conf['general']['htmltemplate'];
		
		if (!$this->conf['general']['pdftemplate']) $this->conf['general']['pdftemplate'] = t3lib_div::getFileAbsFileName($this->TSconf['general.']['pdftemplate']);
		else $this->conf['general']['pdftemplate'] = t3lib_div::getFileAbsFileName('uploads/tx_skcalendar/' . $this->conf['general']['pdftemplate']);
		$this->conf['general']['overrideTF']= $this->TSconf['general.']['overrideTF']; // can only be set via TS for php is not allowed in BE

		// nderungen zur Navigation von johpie
		$this->conf['listmonthview']['nav']['month']= $this->TSconf['listmonthview.']['nav.']['month.']; 
		$this->conf['listmonthview']['nav']['aktmonth']= $this->TSconf['listmonthview.']['nav.']['aktmonth.']; 
		
		// System Values
		$this->conf['system']['LLkey'] = $this->LLkey;
		
		// Usergroup
		
		if ($GLOBALS['TSFE']->fe_user->user['usergroup']) {
			// Haben wir eine Mastergruppe?
			$select_fields = 'uid,subgroup';
			$from_table = 'fe_groups';
			$where_clause = 'NOT hidden AND NOT deleted';
			$orderBy = 'subgroup';
			$return = $GLOBALS['TYPO3_DB']->exec_SELECTquery($select_fields,$from_table,$where_clause,$groupBy,$orderBy);
			if (!$return) {
				debug($GLOBALS['TYPO3_DB']->SELECTquery($select_fields,$from_table,$where_clause,$groupBy,$orderBy));
				debug($GLOBALS['TYPO3_DB']->sql_error());
				}
			$arr = array();
			while ($data= $GLOBALS['TYPO3_DB']->sql_fetch_assoc($return)) {
				$grp_arr[$data['uid']]['uid'] = $data['uid'];
				if($data['subgroup']) $grp_arr[$data['subgroup']]['parent'] = $data['uid'];
			}
			$member_groups = array(0,-2);
			$master = $GLOBALS['TSFE']->fe_user->user['usergroup'];
			while ($master) {
				$member_groups[] = $master;
				$master = $grp_arr[$master]['parent'] ? $grp_arr[$master]['parent'] : FALSE;
			}
			$this->conf['system']['usergroup'] = $member_groups;
		}
		else $this->conf['system']['usergroup'] = array(0,-1);
	}
	
	// this function processes Usersettings like offset or filters, etc.
	function user_settings() {
		// applied filters & Values
		
		// view & Offsettransformation (I hate mondays bug)
		if (!$this->piVars['offset']) $offset = mktime(0,0,0);
		else {
			$offset = explode('-',date('d-m-Y',$this->piVars['offset']));
			$offset = mktime(0,0,0,$offset[1],$offset[0],$offset[2]);
			}
		$this->conf['offset'] = $offset;
		if ($this->piVars['view'] && !$this->conf['general']['keep_view']) $this->conf['general']['view'] = $this->piVars['view'];
		$this->conf['filters']['notch'] = $this->piVars['notch']; // listview
		$this->conf['filters']['sorting'] = $this->piVars['sorting'] ? $this->piVars['sorting'] : 'downdate'; // listview
		
		// Filters may be set default by TS
		$this->conf['filters']['category'][0] = $this->TSconf['filter_cat'] ? $this->TSconf['filter_cat'] : FALSE;
		$this->conf['filters']['targetgroup'][0] = $this->TSconf['filter_tar'] ? $this->TSconf['filter_tar'] : FALSE;
		$this->conf['filters']['location'][0] = $this->TSconf['filter_loc'] ? $this->TSconf['filter_loc'] : FALSE;
		$this->conf['filters']['organizer'][0] = $this->TSconf['filter_org'] ? $this->TSconf['filter_org'] : FALSE;
		
		// other filters by pivars
		if ($this->piVars['targetgroup']) $this->conf['filters']['targetgroup'][0] = $this->piVars['targetgroup'];
		if ($this->piVars['category']) $this->conf['filters']['category'][0] = $this->piVars['category'];
		if ($this->piVars['location']) $this->conf['filters']['location'][0] = $this->piVars['location'];
		if ($this->piVars['organizer']) $this->conf['filters']['organizer'][0] = $this->piVars['organizer'];
		if ($this->piVars['monthfilter']) $this->conf['filters']['monthfilter'] = $this->piVars['monthfilter']; // month filters in Listview
		$this->conf['filters']['sword'] = $this->piVars['sword']; // listview

		// Different views have different Timeranges
		switch ($this->conf['general']['view']) {
			case 'week':
				$offset = $offset - date('w',$offset) * 86400 + 86400; // we like mondays
				$filters['startdate'] = $offset;
				$filters['enddate'] = $this->addDaysToTimestamp($offset,7);
			break;

			case 'box';
				$filters['startdate'] = $offset;
				$filters['enddate'] = $this->addDaysToTimestamp($offset,$this->conf['box']['range']);
			break;

			case 'day':
				$filters['startdate'] = $offset;
				$filters['enddate'] = $this->addDaysToTimestamp($offset,1);
			break;
			
			case 'month':
			case 'listmonth':
				$offset_temp = date('m-d-Y',$offset);
				$offset_temp = explode('-',$offset_temp);
				$start = mktime(0,0,0,$offset_temp[0],1,$offset_temp[2]);
				$end = mktime(0,0,0,$offset_temp[0],31,$offset_temp[2]);
				$filters['startdate'] = $start;
				$filters['enddate'] = $end;
			break;
			
			case 'thumbmonth':
				$offset_temp = date('m-d-Y',$offset);
				$offset_temp = explode('-',$offset_temp);
				// get start_end
				$calendar = new tx_skcalendar_thumbmonthview(array(),$this->conf);
				$calendar->getStartEnd();
				$start = mktime(0,0,0,$calendar->month_start,1,$offset_temp[2]);
				$end = mktime(0,0,0,$calendar->month_end,31,$offset_temp[2]);
				$filters['startdate'] = $start;
				$filters['enddate'] = $end;
			break;

			case 'yearview':
				$offset_temp = date('Y',$offset);
				$start = mktime(0,0,0,1,1,$offset_temp);
				$end = mktime(23,59,59,12,31,$offset_temp);
				$filters['startdate'] = $start;
				$filters['enddate'] = $end;
			break;

			case 'detail':
				$this->conf['filters']['uid'] = $this->piVars['uid'];
				$filters['startdate'] = $offset;
				$filters['enddate'] = $this->addDaysToTimestamp($offset,1);
			break;
			
			case 'upcoming': // same selection like listview.
			case 'list':
			//nderung damit monthfilter angewedet werden kann johpie
			if ($this->piVars['monthfilter']) {
				$filters['startdate'] = $this->piVars['monthfilter'];
				$filters['enddate'] = $this->addMonthsToTimestamp($filters['startdate'],1);
				$offset = $this->piVars['monthfilter'];
			}
			else {
				$filters['startdate'] = $offset;
				$filters['enddate'] = $this->addMonthsToTimestamp($filters['startdate'],48); // 4 Years should be enough unlimited not possible for there might be infinite recurring events
			}
			break;
			
			case 'archive':
			//nderung damit monthfilter angewedet werden kann johpie
			if ($this->piVars['monthfilter']) {
				$filters['startdate'] = $this->piVars['monthfilter'];
				$filters['enddate'] = $this->addMonthsToTimestamp($filters['startdate'],1);
				$offset = $this->piVars['monthfilter'];
			}
			else {
				$filters['startdate'] = 1; // show us everything (0 would disable filter)
				$offset_temp = date('m-d-Y');
				$filters['enddate'] = mktime(0,0,0)-1; // ... until not quite today
				}
			break;


		}
		
		// datefilters
		if ($this->piVars['datefrom']) {
			$filters['datefrom'] = $this->piVars['datefrom'];
			$filters['startdate'] = $this->transformToTimestamp($this->piVars['datefrom']);
		}
		if ($this->piVars['dateto']) {
			$filters['dateto'] = $this->piVars['dateto'];
			$filters['enddate'] = $this->transformToTimestamp($this->piVars['dateto']);
		}
		
		// swap around
		if (($filters['startdate'] > $filters['enddate']) && $filters['enddate']) {
			$filters['datefrom'] = $this->piVars['dateto'];
			$filters['startdate'] = $this->transformToTimestamp($this->piVars['dateto']);
			$filters['dateto'] = $this->piVars['datefrom'];
			$filters['enddate'] = $this->transformToTimestamp($this->piVars['datefrom']);
		}

		
		// Set the ranges
		$this->conf['filters']['datefrom'] = $filters['datefrom'];
		$this->conf['filters']['startdate'] = $filters['startdate'];
		$this->conf['filters']['dateto'] = $filters['dateto'];
		$this->conf['filters']['enddate'] = $filters['enddate'];

	
	}
	
	function transformToTimestamp($date) {
			if($date) {
 		$date = explode('.',$date);
 		if (!$date[2]) $date[2] = date('Y',$this->conf['offset']);
 		$date = mktime(0,0,0,$date[1],$date[0],$date[2]);
 		}
 		return $date;
	}
	
	function addDaysToTimestamp($tstamp,$days) {
		$tstamp = date('m-d-Y',$tstamp);
		$tstamp = explode('-',$tstamp);
		$tstamp = mktime(0,0,0,$tstamp[0],$tstamp[1]+$days,$tstamp[2]);
		return $tstamp;

	}
	
	function addMonthsToTimestamp($tstamp,$months) {
		$tstamp = date('m-d-Y',$tstamp);
		$tstamp = explode('-',$tstamp);
		$tstamp = mktime(0,0,0,$tstamp[0]+$months,$tstamp[1],$tstamp[2]);
		return $tstamp;
	}


}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/sk_calendar/pi1/class.tx_skcalendar_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/sk_calendar/pi1/class.tx_skcalendar_pi1.php']);
}

?>