<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2003 Volker Biberger (info@sitekick.de)
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
* Templateenging Provides basic functions for all other forms of displaying or providing data
*
* @author	Volker Biberger <info@sitekick.de>
*/

class tx_skcalendar_te extends tx_skcalendar_htmlview{
	var $data;
	var $my_cObj;
	var $markers;
	var $code;
	var $subcode;
	var $TempData;
	var $subparts;
	
	function tx_skcalendar_te() {
		$this->my_cObj = t3lib_div::makeInstance('tslib_cObj');
	}
	
	function getSubpart($subpart) {
		$this->subpart_id = $subpart;
		$this->subcode = $this->subparts[$subpart];
		$this->markers['labels'] = array();
		$this->markers['markers'] = array();
		preg_match_all('/###[A-Z_a-z1-9]+###/',$this->subcode,$markers); // get Markers
		while (list(,$value) = each($markers[0])) {
			
			if (strpos($value,'##LABEL_')==1) { // 0 is not a good position
				$value = substr($value,9,strlen($value)-12);
				$this->markers['labels'][]=$value; 
			}
			else {
				$value = substr($value,3,strlen($value)-6);
				$this->markers['markers'][] = $value;
			}
		}
		}
		
	function setTempData($data) {
		$this->TempData = $data;
	}
	
	function setCode ($code) {
		$this->tx_skcalendar_te(); // init Cobj
		$this->code = $code;
		}
		
	function registerSubparts($subpart_ids) {
		$this->subparts['ALL'] = $this->code;
		while (list(,$subpart_id) = each ($subpart_ids)) {
			// analysieren der einzelnen Subparts
			reset($this->subparts);
			while (list($key) = each($this->subparts)) {
				$code = $this->my_cObj->getSubpart($this->subparts[$key],$subpart_id);
				if ($code) {
					$this->subparts[$subpart_id] = $code;
					$start_char = strpos($this->subparts[$key],'<!--###'.$subpart_id.'### begin');
					$end_char = strpos($this->subparts[$key],'<!--###'.$subpart_id.'### end');
					$replace = substr($this->subparts[$key],$start_char,$end_char-$start_char+strlen('<!--###'.$subpart_id.'### end -->'));
					
					$this->subparts[$key] = str_replace($replace,'###wrapit_' . $subpart_id . '###',$this->subparts[$key]);
				}
			}
		}
		//debug($this->subparts);

	}
	
	function setTemplate($container,$conf) {
		$this->tx_skcalendar_feengine($container,$conf);
	}
	
	function setItem($data) {
		
		//Setzt DAM Bilder
		$confArr = unserialize($GLOBALS['TYPO3_CONF_VARS']['EXT']['extConf']['sk_calendar']);
		if ($confArr['usedam'] < 2)  
			$data['image'] = $data['image'] ? '<img src="uploads/tx_skcalendar/' . $data['image'] . '">' : FALSE;
		  else $data['image'] = FALSE;
		if ($confArr['usedam'])  {
			if ($data['dam_image']) {
				$damFiles = tx_dam_db::getReferencedFiles('tx_skcalendar_event', $data['uid'], 'dam_image');
				while (list(,$val) = each($damFiles['files'])) {
					$data['image'] = '<img src="'.$val.'">';
				}
			}
		}
	
		while (list($key,$value) = each($data)) {
			$this->data['e_'.$key] = $value; // e as event
			}
		if ($data['category']) {
			while (list($key,$value) = each($data['category'])) {
			$this->data['c_'.$key] = $value; // c as category
			}
			}
		if ($data['organizer']) {
			while (list($key,$value) = each($data['organizer'])) {
			$this->data['o_'.$key] = $value; // o as organizer
			}
			}
		if ($data['targetgroup']) {
			while (list($key,$value) = each($data['targetgroup'])) {
			$this->data['t_'.$key] = $value; // t as Targetgroup
			}
			}
		if ($data['location']) {
			while (list($key,$value) = each($data['location'])) {
			$this->data['l_'.$key] = $value; // l as Location
			}
			}
		}
	
	function parseTemplate() {
		// Marker Ersetzen

		while (list(,$marker) = each($this->markers['labels'])) {
			$this->marker_array['###LABEL_'.$marker.'###'] = $this->pi_getLL(strtolower($marker));
			}
		while (list(,$marker) = each($this->markers['markers'])) {
			$function = 'templatefunc_'.strtolower($marker);
			// do we have any wrapits?
			if (strpos($marker,'wrapit') !== FALSE) {
 				$this->TempData['wrapit'] = $this->TempData[$marker];
 				$this->templatefunc_wrapit();
 				$this->marker_array['###'.$marker.'###'] = $this->getSnippet();
 			}
 			elseif(method_exists($this,$function)) {
				$this->$function($this->data[strtolower($marker)]);
				$this->marker_array['###'.$marker.'###'] = $this->getSnippet();
			}
			else $this->marker_array['###'.$marker.'###'] = $this->data[strtolower($marker)];
		}
		

		$return = $this->my_cObj->substituteMarkerArrayCached($this->subcode, $this->marker_array);
		
		// Debug function for template recursion
		if ($this->debug) {
 			echo '<br><br>'; 
 			debug('---');
//			debug($this->subpart_id);
//	 		debug($this->subcode);
	 		debug($this->TempData);
	 		debug($this->data);
	 		debug($this->marker_array);
//	 		debug($return);
		}
 		unset($this->tempData);
		unset($this->data);
		return $return;
	}
	
	function getSnippet() {
		$code = $this->snippet;
		unset ($this->snippet);
		return $code;
		}
}

if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/sk_calendar/pi1/class.tx_skcalendar_te.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/sk_calendar/pi1/class.tx_skcalendar_te.php"]);
}

?>