<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2004 Volker Biberger / sitekick.de <info@sitekick.de>
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/


// Manage HTML-View of Data

class tx_skcalendar_thumbmonthview extends tx_skcalendar_monthview {

	function tx_skcalendar_thumbmonthview($container,$conf) {
		// calls mothership
		$this->tx_skcalendar_monthview($container,$conf);
	}
	
	function getStartEnd() {

	// How many months are there to display? 
		$month = intval(date('m',$this->offset));
//		$even = $this->conf['thumbmonth']['thumbmonths']%2 ? FALSE : TRUE;
//		$this->month_start = $month - floor($this->conf['thumbmonth']['thumbmonths'] / 2) + $even;
//		$this->month_end = $this->month_start + $this->conf['thumbmonth']['thumbmonths']-1;
		$this->month_start = $month;
		$this->month_end = $month + $this->conf['thumbmonth']['thumbmonths'] -1;
		//$this->content .= $this->month_start.'<br>';
		//$this->content .= $this->month_end.'<br>';
	
	}

	function parseCalendar() {
	
		// register subparts
		$subparts = array(
			'THUMBMONTH_VIEW_DAYWRAP',
			'THUMBMONTH_VIEW_ROWWRAP',
			'THUMBMONTH_VIEW_CALENDARWRAP',
			'THUMBMONTH_VIEW_NAVIGATION',
			'THUMBMONTH_VIEW_WHOLEWRAP');
			
		$this->template->registerSubparts($subparts);
		if ($this->conf['general']['showlinks']) $this->makeLinks();
		if ($this->conf['general']['showfilters']) $this->makeFilters();
		
		// Months to display
		$this->getStartEnd();
		//$this->content .= t3lib_div::view_array($this->conf['filters']);
		$year = $this->year;
		for ($month=$this->month_start; $month <= $this->month_end; $month++) {
			
			// skip year // events are missing yet
			if ($month == 13) {
				$month = 1;
				$this->month_end -= 12;
				$year++;
			}
		
		
			$content = '';
			//$this->content .= $month.' -> ' . $this->month_end . '<br />';
			// calculate offset
			$weekday = date('w',mktime(0,0,0,$month,1,$year));
			if ($weekday == 0) $weekday=7;
			$d=$weekday-(($weekday-1)*2);
		
			// amount weeks
			$days = date('t',mktime(0,0,0,$month,1,$year))-28;
			$days = $days+$weekday-1;// How many overhanging days?
			if ($days > 7) $count_weeks=6;
			elseif ($days == 0) $count_weeks=4;
			else $count_weeks = 5;
			
			for ($w=1; $w<=$count_weeks;$w++) {
				for ($i=1;$i<=7;$i++) {
					//$this->content .= $month.' '.$d.' '.$i.' '.$shadow.' '.$this->calendarArray[$month][$d]['d_name']['no'].'<br>';
					$temp['style'] = 'thumbmonth_' . $this->calendarArray[$month][$d]['style'];
					$temp['date'] = mktime(0,0,0,$month,$d,$year);
					$temp['timestamp'] = $temp['date'];
					if ($this->calendarArray[$month][$d]['events'] && !$shadow) {
					while (list(,$event) = each ($this->calendarArray[$month][$d]['events'])) {
						// add style information
						$temp['style'] .= $event['category'] ? ' thumbmonth_cat' . $event['category']['uid'] : '';
						$temp['style'] .= $event['targetgroup'] ? ' thumbmonth_tar' . $event['targetgroup']['uid'] : '';
						$temp['style'] .= $event['location'] ? ' thumbmonth_loc' . $event['location']['uid'] : '';
						$temp['style'] .= $event['organizer'] ? ' thumbmonth_org' . $event['organizer']['uid'] : '';
					}
						// prepare Typolink
						$link['tx_skcalendar_pi1[offset]'] = $this->calendarArray[$month][$d]['d_ts'];
						$link['tx_skcalendar_pi1[view]'] = 'day';
						$link['no_cache'] = 1; 
						// nderung Detailseite wird genutzt wenn bergeben johpie
						if ($this->conf['general']['detail_pid']) {
							$temp['name'] = '<a href="' . $GLOBALS["TSFE"]->cObj->getTypoLink_URL($this->conf['general']['detail_pid'],$link) . '">' . $this->calendarArray[$month][$d]['d_name']['no'] . '</a>';
						} else {
							//nderung Link wird sonst an Stellen angezeigt wo er nicht hingehrt johpie
							//$content .='<a href="' . $GLOBALS["TSFE"]->cObj->getTypoLink_URL($GLOBALS["TSFE"]->id,$link) . '">';
							$temp['name'] = '<a href="' . $GLOBALS["TSFE"]->cObj->getTypoLink_URL($GLOBALS["TSFE"]->id,$link) . '">' . $this->calendarArray[$month][$d]['d_name']['no'] . '</a>';
						}
					}
					else $temp['name'] = $this->calendarArray[$month][$d]['d_name']['no'];		

	
					if ($this->calendarArray[$month][$d]['d_ts']) $temp['timestamp'] = $this->calendarArray[$month][$d]['d_ts'];	

				
				
					// Make my day
					$temp['wrapit_THUMBMONTH_VIEW_ITEM'] = $content_day;
					$this->template->setTempData($temp);
					$this->template->getSubpart('THUMBMONTH_VIEW_DAYWRAP');
					$content_row .= $this->template->parseTemplate();
					unset ($content_day);
					$d++;
				}

				// close row
				$temp['wrapit_THUMBMONTH_VIEW_DAYWRAP'] = $content_row;
				$this->template->setTempData($temp);
				$this->template->getSubpart('THUMBMONTH_VIEW_ROWWRAP');
				$content .= $this->template->parseTemplate();
				unset ($content_row);

			}
		
			$temp['date'] = $this->offset;
			$temp['wrapit_THUMBMONTH_VIEW_ROWWRAP'] = $content;
			$this->template->setTempData($temp);
			$this->template->getSubpart('THUMBMONTH_VIEW_CALENDARWRAP');
			$temp['wrapit_THUMBMONTH_VIEW_CALENDARWRAP'] = $this->template->parseTemplate();
			
			// get Navigation
			$this->template->setTempData($this->makeNavigation($month));
			$this->template->getSubpart('THUMBMONTH_VIEW_NAVIGATION');
			$temp['wrapit_THUMBMONTH_VIEW_NAVIGATION'] = $this->template->parseTemplate();
				
			// wrap whole thing
			$this->template->setTempData($temp);
			$this->template->getSubpart('THUMBMONTH_VIEW_WHOLEWRAP');
			$content =  $this->template->parseTemplate();
	
			// shadow hardcoded!!!
			if ($shadow) $content = str_replace('<table class="thumbmonthview">','<table class="thumbmonthview_shadow">',$content);
			$this->content .= $content;
			$shadow = TRUE;
		}
	}
	
	function makeNavigation($month) {
		$offset = $month;
		$next = $this->prepareTypolink();
		$back = $this->prepareTypolink();
		$nextyear = $this->prepareTypolink();
		$backyear = $this->prepareTypolink();
		
		$next['tx_skcalendar_pi1[offset]'] = mktime(0,0,0,$this->month_start+1,1,$this->year);
		$back['tx_skcalendar_pi1[offset]'] = mktime(0,0,0,$this->month_start-1,1,$this->year);
		//nderung Weiteransicht bleibt bei thumbs johpie
		$next['tx_skcalendar_pi1[view]'] = 'thumbmonth';
		$back['tx_skcalendar_pi1[view]'] = 'thumbmonth';

		if ($month == $this->month_start) $navi['backlink'] = '<a href="' . $GLOBALS["TSFE"]->cObj->getTypoLink_URL($GLOBALS["TSFE"]->id,$back) . '"> < </a>';
		else $navi['backlink'] = '&nbsp;';
		if ($month == $this->month_end) $navi['nextlink'] = '<a href="' . $GLOBALS["TSFE"]->cObj->getTypoLink_URL($GLOBALS["TSFE"]->id,$next) . '"> > </a>';
		else $navi['nextlink'] = '&nbsp;';
		$navi['date'] =  mktime(0,0,0,$offset,1,$this->year);
		return $navi;	
		}

	}

if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/sk_calendar/pi1/class.tx_skcalendar_thumbmonthview.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/sk_calendar/pi1/class.tx_skcalendar_thumbmonthview.php"]);
}
