<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2004 Volker Biberger / sitekick.de <info@sitekick.de>
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/


// Manage HTML-View of Data

class tx_skcalendar_yearview extends tx_skcalendar_htmlview {

	function tx_skcalendar_yearview($container,$conf) {
		// calls mothership

		$this->tx_skcalendar_htmlview($container,$conf);
		
	}

	function parseCalendar() {
		$this->year = intval(date('Y',$this->offset));
		// register subparts
		$subparts = array(
			'YEAR_VIEW_ITEM',
			'YEAR_VIEW_MONTHWRAP',
			'YEAR_VIEW_ROWWRAP',
			'YEAR_VIEW_CALENDARWRAP',
			'YEAR_VIEW_NAVIGATION',
			'YEAR_VIEW_WHOLEWRAP');
		$this->template->registerSubparts($subparts);
	//	$this->template->debug= 1;
		
		for ($q=1; $q<=4;$q++) { // Quartale
			for ($i=1;$i<=3;$i++) { // Monate
				$month++;
				
				$temp['style'] = 'col_' . $i;
				$temp['date'] = mktime(0,0,0,$month,1,$this->year);
				
				// Gibt es events in diesem Monat
				for ($d=1; $d<=31; $d++) {
					if ($this->calendarArray[$month][$d]['events']) {
						while (list(,$data) = each($this->calendarArray[$month][$d]['events'])) {
						$temp['style'] .= $data['category'] ? ' year_cat' . $data['category']['uid'] : '';
						$temp['style'] .= $data['targetgroup'] ? ' year_tar' . $data['targetgroup']['uid'] : '';
						$temp['style'] .= $data['location'] ? ' year_loc' . $data['location']['uid'] : '';
						$temp['style'] .= $data['organizer'] ? ' year_org' . $data['organizer']['uid'] : '';
						if ($this->conf['month']['iconmode']) {
						$cat = $this->getCategory($data['category']);
						if (!$cat['icon']) $cat['icon'] = 'cat_fallback.gif';
						$linktext = '<img border=0 width=10 src="uploads/tx_skcalendar/'.  $cat['icon'] . '">';
						}
						else $linktext = $data['title'];
						$temp['linktext'] = $linktext;
						$this->template->setItem($data);
						$this->template->setTempData($temp);
						$this->template->getSubpart('YEAR_VIEW_ITEM');	

						$content_month .= $this->template->parseTemplate();	
						}
					}
				}
				
				// Make my month
				$temp['wrapit_YEAR_VIEW_ITEM'] = $content_month;
				$this->template->setTempData($temp);
				$this->template->getSubpart('YEAR_VIEW_MONTHWRAP');
				$content_row .= $this->template->parseTemplate();
				
				unset ($content_month);
				$d++;
			}

			// close row
			$temp['wrapit_YEAR_VIEW_MONTHWRAP'] = $content_row;
			$this->template->setTempData($temp);
			$this->template->getSubpart('YEAR_VIEW_ROWWRAP');
			$content .= $this->template->parseTemplate();
			
			unset ($content_row);

		}
		
		$temp['date'] = $this->offset;
		$temp['wrapit_YEAR_VIEW_ROWWRAP'] = $content;
		$this->template->setTempData($temp);
		$this->template->getSubpart('YEAR_VIEW_CALENDARWRAP');
		$content = $this->template->parseTemplate();
		
		// get Navigation
		$this->template->setTempData($this->makeNavigation());
		$this->template->getSubpart('YEAR_VIEW_NAVIGATION');
		$temp['wrapit_YEAR_VIEW_NAVIGATION'] = $content . $this->template->parseTemplate();

		// wrap whole thing
		$this->template->setTempData($temp);
		$this->template->getSubpart('YEAR_VIEW_WHOLEWRAP');
		$this->content .= $this->template->parseTemplate();
	}

	function makeNavigation() {
		$nextyear = $this->prepareTypolink();
		$backyear = $this->prepareTypolink();
		
		$backyear['tx_skcalendar_pi1[offset]'] = mktime(0,0,0,1,1,$this->year-1);
		$nextyear['tx_skcalendar_pi1[offset]'] = mktime(0,0,0,1,1,$this->year+1);

		$navi['backlinkyear'] = '<a href="' . $GLOBALS["TSFE"]->cObj->getTypoLink_URL($GLOBALS["TSFE"]->id,$backyear) . '"> << ' . strftime("%Y",mktime(0,0,0,1,1,$this->year-1)) . '</a>';
		$navi['nextlinkyear'] = '<a href="' . $GLOBALS["TSFE"]->cObj->getTypoLink_URL($GLOBALS["TSFE"]->id,$nextyear) . '">' . strftime("%Y",mktime(0,0,0,1,1,$this->year+1)) . ' >></a>';
		return $navi;
	}
}

if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/sk_calendar/pi1/class.tx_skcalendar_yearview.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/sk_calendar/pi1/class.tx_skcalendar_yearview.php"]);
}
